//  **** BEGIN LICENSE BLOCK ****
//  Copyright (C) 2003 Davide Carboni
//
//  This software is distributed under the terms of GPL
//  **** END LICENSE BLOCK ****

var oHTTPListener;


function startHTTPListener() {
  alert('Starting HTTP Listener');
  oHTTPListener = new HTTPListener();
  

  // Register new request and response listener
  if ('nsINetModuleMgr' in Components.interfaces) {
    // Should be an old version of Mozilla/Phoenix (before september 15, 2003)
    var netModuleMgr = Components.classes["@mozilla.org/network/net-extern-mod;1"].getService(Components.interfaces.nsINetModuleMgr);
    netModuleMgr.registerModule("@mozilla.org/network/moduleMgr/http/request;1", oHTTPListener);
    netModuleMgr.registerModule("@mozilla.org/network/moduleMgr/http/response;1", oHTTPListener)
  } else {
    // Should be a new version of  Mozilla/Phoenix (after september 15, 2003)
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(oHTTPListener, "http-on-modify-request", false);
    observerService.addObserver(oHTTPListener, "http-on-examine-response", false);
  }
}
function stopHTTPListener() {
  // Unregistering listener
  if ('nsINetModuleMgr' in Components.interfaces) {
    // Should be an old version of Mozilla/Phoenix (before september 15, 2003)
    var netModuleMgr = Components.classes["@mozilla.org/network/net-extern-mod;1"].getService(Components.interfaces.nsINetModuleMgr);
    netModuleMgr.unregisterModule("@mozilla.org/network/moduleMgr/http/request;1", oHTTPListener);
    netModuleMgr.unregisterModule("@mozilla.org/network/moduleMgr/http/response;1", oHTTPListener);
  } else {
    // Should be a new version of  Mozilla/Phoenix (after september 15, 2003)
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.removeObserver(oHTTPListener, "http-on-modify-request");
    observerService.removeObserver(oHTTPListener, "http-on-examine-response");
  }

  
  delete oHTTPListener;
  oHTTPListener = null;
}

function HTTPListener()
{}
HTTPListener.prototype =
{
  // Constants
  // Type
  
  // This is the observerService's observe listener.
  observe: function(aSubject, aTopic, aData) {
    if (aTopic == 'http-on-modify-request') {
      aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
      this.onModifyRequest(aSubject);
    } else if (aTopic == 'http-on-examine-response') {
      aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
      this.onExamineResponse(aSubject);
    }
  },


  readLocationFromDevice : function ()
  {
	   // a local file path 
	   include (jslib_file);
	   var loc="No_Location_Available";
	   try{
		  var gpsDeviceFile=document.getElementById("location-device").value;
		  var f = new File(gpsDeviceFile);
		  //alert(f.exists());
		  if(f.exists()){
			  f.open();
			  loc=f.read();
			  f.close();
		  }
	   }
	   catch(e){}
	   
	   return loc;
  },
  
  onModifyRequest : function (oHttp)
  {

    var userLocation=this.readLocationFromDevice();
    oHttp.setRequestHeader("User-Location", userLocation  , false);
    document.getElementById("current-location").value=userLocation;
    //this.onExamineResponse(oHttp);

  },
  onExamineResponse : function (oHttp)
  {  },


  QueryInterface: function(iid) {
    if (!iid.equals(Components.interfaces.nsISupports) &&
        !iid.equals(Components.interfaces.nsIHttpNotify) &&
        //!iid.equals(Components.interfaces.nsIClassInfo) &&
        //!iid.equals(Components.interfaces.nsISecurityCheckedComponent) &&
        //!iid.equals(Components.interfaces.nsIWeakReference) &&
        !iid.equals(Components.interfaces.nsIHttpNotify) &&
        !iid.equals(Components.interfaces.nsIObserver)) {
          //dump("LiveHTTPHeaders: QI unknown iid: " + iid + "\n");
          throw Components.results.NS_ERROR_NO_INTERFACE;
      }
      return this;
    }


}


function txtFilePicker() {
  var filename = null;
  try {
   
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
    fp.init(window, "Select GPS device file...", nsIFilePicker.modeOpen);
    fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);
    
    var result=fp.show();
    if (result == nsIFilePicker.returnOK || result == nsIFilePicker.returnReplace) {
      
      filename=fp.file.path;
      alert("You selected "+filename+" as your GPS device file");
    }
  }
  catch (ex) {
  }
  
  document.getElementById("location-device").value=filename;
  
}
